#define __noreturn __attribute__ ((noreturn))
#define __malloc __attribute__ ((malloc))
#define __a_unused __attribute__ ((unused))
#define __a_aligned(alignment) __attribute__((__aligned__(alignment)))

/*
 * p is the number of the "format string" parameter, and q is the number of the
 * first variadic parameter. If q is specified as zero, the compiler only
 * checks the format string for consistency.
 */
# define __printf(p,q) __attribute__ ((format (printf, p, q)))
# define __a_const __attribute__ ((const))

/*
 * As direct use of __printf(p,q) confuses doxygen, here are some extra macros
 * for those values p,q that are actually used.
 */
#define __printf_2_0 __printf(2,0)
#define __printf_1_2 __printf(1,2)
#define __printf_2_3 __printf(2,3)
#define __printf_3_4 __printf(3,4)

#define __must_check __attribute__ ((warn_unused_result))
#define _static_inline_ static inline
